<!doctype html public "-//w3c//dtd html 4.0 transitional//en">
<html>
<head>
   <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
   <meta name="GENERATOR" content="Mozilla/4.7 [en] (X11; I; Linux 2.2.10 i686) [Netscape]">
   <title>JFLA 2000</title>
</head>
<body bgcolor="#FFFFFF">

<center>
<h1>
JFLA 2000: relecture du papier 14</h1></center>
Numero du papier: 14
<p>Titre du papier: Affichage g&eacute;n&eacute;rique d'arbres &agrave;
l'aide de la g&eacute;om&eacute;trie hyperbolique
<p>Auteurs: Alexandre Miquel
<p>Nom du rapporteur:Maria Virginia Aponte aid&eacute;e par Alexandre Topol
(doctorant du Cnam en multimedia) pour la partie "techniques d'affichage
de l'article).
<p>Confiance en la note: 3
<p>Notation du papier: entre 2 et 3
<br>&nbsp;
<p>Commentaires aux auteurs:
<p>&nbsp;1. L'ajout d'une bibliographie, notamment en ce qui concerne l'algorithme
d'affichage est indispensable.
<br>2. Y a-t-il d'autres choix d'abstraction que ceux fournis par le langages
de modules et/ou par les enregistrements? Par exemple, pourrait-on employer
de classes + le m&eacute;canisme d'h&eacute;ritage pour expliquer l'extension
d'arbres, puis les encapsuler dans des modules pour permettre l'abstraction
du type des arbres? Quel est l'interet des uns par rapport aux autres?
<p>Commentaires reserves au comite de programme:
<p><u>Resum&eacute; comment&eacute;</u><u></u>
<p>L'article pr&eacute;sente un programme g&eacute;n&eacute;rique d'affichage
d'arbres, utilisant des techniques de g&eacute;ometrie hyperbolique. Cette
technique permet l'affichage et la navigation sur des structures de taille
bien plus grande que celles ou` la g&eacute;ometrie euclidienne est employ&eacute;e.
Une pr&eacute;sentation des notions de g&eacute;ometrie hyperbolique ainsi
que de l'algorithme d'affichage est donn&eacute;e dans les 5 premieres
pages apres l'introduction. Ces notions et techniques sont amplement connues
dans le domaine d'Interface Homme-Machine, et plusieurs afficheurs de ce
genre existent sur le march&eacute;. De meme, les applications r&eacute;alis&eacute;s
par l'auteur (affichage d'arborescence de r&eacute;pertoires, le dictionnaire
des dictionnaires), ou qui sont propos&eacute;es dans les perspectives
(affichage de l'organisation d'un site Web), ont d&eacute;ja` &eacute;t&eacute;
r&eacute;alis&eacute;es ailleurs depuis quelques ann&eacute;es. Il est
regrettable que l'auteur ne donne aucune r&eacute;f&eacute;rence bibliographique
a` ce sujet. Donc, si interet ou originalit&eacute; il y a dans l'article,
elle est a` chercher autour de l'aspect application d'un langage fonctionnel
(Ocaml).
<p>Le programme implant&eacute; utilise les modules et les enregistrement
d'OCaml pour abstraire plusieurs notions:
<br>* notion d'arbre: un type de structure HTREE qui contient un type abstrait
pour representer les arbres
<br>* notion de moteur graphique: un enregistrement avec des fonctions
d'affichage.
<br>* foncteur d'extension d'arbres HTREE : extension d'un arbre g&eacute;n&eacute;rique
vers un arbre enrichi d'un moteur d'affichage et d'autres fonctions d'affichage
<br>* foncteur d'extension d'arbre pour interfacage graphique GTREE: &eacute;tend
un arbre g&eacute;n&eacute;rique en un arbre avec informations sur le contenu
dans les &eacute;tiquettes de l'arbre. Il est construit en utlisant le
foncteur HTREE. Toutes ces abstractions sont de 1er ordre (pas de foncteur
de foncteurs, ni de signature parametr&eacute;e).
<br>Chacune d'entre elles fait entre 4 et 10 lignes. Le code des foncteurs
n'est pas fourni dans l'article.
<p><u>R&eacute;alisations</u>
<p>(a) Le programme d'affichage g&eacute;n&eacute;rique &eacute;crit en
Ocaml (moins de 700) lignes.
<br>(b) Deux applications:
<br>i) Affichage des r&eacute;pertoires d'un systeme de fichiers Unix:
Ici se trouve peut-etre l'application la plus int&eacute;ressante d'Ocaml
pour ce genre d'algorithme d'affichage. Les fils d'un r&eacute;pertoire
sont repr&eacute;sent&eacute;s par une liste avec une valeur paresseuse
susceptible de s'&eacute;valuer sur la liste des descendants directs du
r&eacute;pertoire. Ainsi, le calcul de toute l'arborescence n'est pas n&eacute;cessaire
avant de commencer l'affichage de l'arbre, mais il se fait a` la demande.
<br>ii) L'arbre infini des mots construits sur l'alphabet latin: "Le dictionnairre
des dictionnaires".
<p>L'auteur donne l'adresse de sa page Web ou` se trouverait le programme
<br>(a). Je ne l'ai pas trouve ni dans sa page ni dans les applications
Caml du projet Cristal.
<p><u>Forme et clart&eacute;</u>
<p>L'article est tres bien &eacute;crit. Les notions techniques sont bien
expliqu&eacute;es, ainsi que le code Ocaml. Un tres mauvais point est l'absence
totale de bibliographie (inexistante).
<p><u>Evaluation</u>
<p>Cet article est simple, bien &eacute;crit, agr&eacute;able a` lire,
avec meme un peu de fraicheur. Il est clair qu'il est sans interet en ce
qui concerne l'originalit&eacute; de la m&eacute;thode d'affichage, il
peut etre cependant int&eacute;ressant de le faire connaitre dans notre
communaut&eacute;, mais cela n'est certaienement pas un argument suffisant
pour accepter l'article. L'intere^t du travail ne peut se trouver qu'au
rang des applications en Ocaml. Or, en tant qu'application du langage de
modules, les abstractions et foncteurs propos&eacute;s sont assez &eacute;l&eacute;mentaires.
Ceci est probablement du fait que les notions a` abstraire et leurs relations
reciproques semblent plutot simples. L'application la plus int&eacute;ressante
du langage semblel'utilisation d'une repr&eacute;sentation paresseuse des
arborescences afin d'optimiser le temps d'affichage. Il reste qu'on aimerait
avoir plus d'exemples "ludiques" de ce genre pour initier nos &eacute;tudiants
aux potentialit&eacute;s d'abstractiond'Ocaml, que ce soit avec le langage
de modules et/ou avec les objets, etc. Malheureusement, cette direction
n'est pas suffisamment exploit&eacute;e dans l'article. En effet, la description
du code est assez sommaire, et les choix d'implantation ne sont pas confront'es
a` d'autres m&eacute;canismes d'abstraction fournie par le langage. C'est
dans la re-orientation de l'article vers une analyse plus critique et plus
diverse des choix d'abstraction parmi tous les m&eacute;canismes offerts
par Ocaml que je vois une r&eacute;-orientation possible de l'article.
Par exemple, il me semble que l'on pourrait m&eacute;langer avec bonheur
modules et objets dans cet exemple (et si ce n'est pas le cas, pourquoi).
<p><u>Conclusion</u>
<p>Mon avis est partag&eacute;. L'article est agreable mais je trouve l'aspect
application en Ocaml un peu trop simplet, meme s'il est certainement a`
placer du cote des (plutot rares) applications ludiques et non orient&eacute;s
langages d'Ocaml. Il me semble qu'une re-maniement assez s&eacute;rieux
de l'article dans la direction "analyse des divers choix d'abstraction"
est n&eacute;cessaire. Pour l'instant il s'agit d'un compte-rendu pas tres
&eacute;labor&eacute; d'une application amusante.
<br>&nbsp;
<br>&nbsp;
<br>&nbsp;
</body>
</html>
